package asm

// Comment adds a comment at the current position.
func (a *Assembler) Comment(text string) {
	a.Label(COMMENT, text)
}

// DLLCall calls a function in a DLL file.
func (a *Assembler) DLLCall(name string) {
	a.Label(DLLCALL, name)
}

// Return returns back to the caller.
func (a *Assembler) Return() {
	a.Instructions = append(a.Instructions, Instruction{Mnemonic: RETURN})
}

// Syscall executes a kernel function.
func (a *Assembler) Syscall() {
	a.Instructions = append(a.Instructions, Instruction{Mnemonic: SYSCALL})
}
