package asm

import (
	"fmt"

	"git.urbach.dev/cli/q/src/cpu"
)

// RegisterLabel operates with a register and a label.
type RegisterLabel struct {
	Label    string
	Register cpu.Register
}

// String returns a human readable version.
func (data *RegisterLabel) String() string {
	return fmt.Sprintf("%s, %s", data.Register, data.Label)
}

// RegisterLabel adds an instruction with a register and a label.
func (a *Assembler) RegisterLabel(mnemonic Mnemonic, register cpu.Register, label string) {
	a.Instructions = append(a.Instructions, Instruction{
		Mnemonic: mnemonic,
		Type:     TypeRegisterLabel,
		Index:    Index(len(a.Param.RegisterLabel)),
	})

	a.Param.RegisterLabel = append(a.Param.RegisterLabel, RegisterLabel{
		Register: register,
		Label:    label,
	})
}
