package x86

import "git.urbach.dev/cli/q/src/cpu"

// memoryAccess encodes a memory access.
func memoryAccess(code []byte, opCode8 byte, opCode32 byte, register cpu.Register, base cpu.Register, offset int8, length byte) []byte {
	opCode := opCode32

	if length == 1 {
		opCode = opCode8
	}

	mod := AddressMemory

	if offset != 0 || base == RBP || base == R13 {
		mod = AddressMemoryOffset8
	}

	if length == 2 {
		code = append(code, 0x66)
	}

	code = encode(code, mod, register, base, length, opCode)

	if base == RSP || base == R12 {
		code = append(code, SIB(Scale1, 0b100, 0b100))
	}

	if mod == AddressMemoryOffset8 {
		code = append(code, byte(offset))
	}

	return code
}
